---
title: 'Privacy, permissions, and information security'
slug: Web/Privacy
tags:
  - Feature Policy
  - Information
  - Permissions
  - Personalize
  - Privacy
  - Protection
  - Web
  - allow
  - allowlist
  - data
  - permission
  - personal
---
<p>{{draft}}</p>

<p>As users use the web for more and more of their daily tasks, more of their private or personally-identifying information they share, ideally only with sites they trust. Cooperation among web content, the web browser, and the web server is needed to achieve as much privacy and information security as possible. <span class="seoSummary">In this article, we examine how to create web content that minimizes the risk of users' personal information or imagery being obtained unexpectedly by third parties.</span></p>

<h2 id="Security_and_privacy_defined">Security and privacy defined</h2>

<p>Before we go into any depth about the various security and privacy features available to users on the web, let's define some important terms.</p>

<dl>
 <dt>Personally identifiable information</dt>
 <dd>
 <p>Personally identifiable information (PII) is information which can be used, in whole or in part, to track down and/or identify a specific person. As such, PII extends beyond the web to all aspects of life. For example, if a site leaks a list of users' names and zip codes online, a bad actor could almost certainly track down at least some percentage of those users by using the corresponding phone books.</p>

 <p>Personally identification can include information like usernames, real names, passwords, phone numbers or addresses (or even portions of them), information about medical history, Social Security Numbers, driver licenses, or any other form of ID or ID number, credit card information, and so forth. It's a very broad range of information. Whenever working with data, always stop and think: is there any way this can be used to even through many steps identify a specific person?</p>
 </dd>
 <dt>Privacy</dt>
 <dd>
 <p>The concept of privacy is somewhat hard to define. Everyone has some idea what it means to keep something private, but when talking about the privacy of data, it becomes murky. Fundamentally, privacy of your data on the internet is about ensuring that information that has personal implications is kept out of the hands of unauthorized persons or organizations, regardless of how it's obtained.</p>

 <p>Privacy exceptions may be granted to specific sites or applications, but it may also be granted <em>conditionally</em>, such as by permitting only a select group of people to access it, or only allowing the information to be accessed and used for a limited period of time.</p>
 </dd>
 <dt>Security</dt>
 <dd>
 <p>Security is about the active protection of data or a system against being accessed, downloaded, or operated by people or organizations that don't have permission to do so. Good security practices aim to prevent unauthorized access to systems or data, regardless of what the target is.</p>
 </dd>
</dl>

<h2 id="Personal_and_private_information">Personal and private information</h2>

<p>&lt;what kind of information is private or personal?&gt;</p>

<h2 id="Privacy_risks">Privacy risks</h2>

<p>&lt;what are ways personal information can be gotten by third parties?&gt;</p>

<h3 id="Fingerprinting">Fingerprinting</h3>

<p><strong>Fingerprinting</strong> is a technique used to gather a variety of information that's made available by a user's browser and collating it until it becomes possible to uniquely identify that user's browser. Even seemingly innocuous information can in principle be used in the fingerprinting process, though the more unique the information is to the particular device the better.</p>

<p>Modern browsers take steps to help prevent fingerprinting-based attacks by either not allowing information to be accessed or, where the information must be made available, by introducing variations that prevent it from being used for identification purposes.</p>

<p>For example, if a web site queries a user's browser for the elapsed time, a comparison of that time to the time as reported by the server might be useful as a factor in fingerprinting. Because of this, browsers typically introduce a small amount of variability to timers in order to make them less useful for identifying the user's system.</p>

<h2 id="Privacy_and_security_controls">Privacy and security controls</h2>

<p>There are multiple layers of controls for helping to protect users against security and privacy breaches. These start at the web server, include the very communication layer used over the network,  and then extend through the web browser's security offerings before reaching your web app code and the efforts it takes to secure itself and the data the user entrusts to it.</p>

<p>There are several web technologies and features at play to manage privacy and security. The following list includes features affecting both, since many of these features are used for both.</p>

<table class="standard-table" style="max-width: 42rem;">
 <caption>Web technologies and features used to enforce security and privacy</caption>
 <thead>
  <tr>
   <th scope="col">Technology or feature</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a href="/en-US/docs/Web/Security/Certificate_Transparency">Certificate Transparency</a></td>
   <td>An open standard for monitoring and auditing certificates, creating a database of public logs that can be used to help identify incorrect or malicious certificates</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/HTTP/CSP">Content Security Policy </a></td>
   <td>Provides the ability to define the extent to which a document's content can be accessed by other devices over the web; used in particular to prevent or mitigate attacks on the server</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a></td>
   <td>Lets web developers selectively enable, disable, and modify the behavior of certain features and APIs both for a document and for subdocuments loaded in {{HTMLElement("iframe")}}s</td>
  </tr>
  <tr>
   <td>{{HTMLElement("iframe")}}'s {{htmlattrxref("allow")}} attribute</td>
   <td>Technically part of Feature Policy, the <code>allow</code> attribute on an <code>&lt;iframe&gt;</code> specifies which web features the document in the frame should be allowed to access</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/HTTP/Public_Key_Pinning">HTTP Public Key Pinning</a> (HPKP)</td>
   <td>HPKP is used by servers to instruct a client to associate a specific public key with the server going forward in order to decrease the likelihood of man-in-the-middle attacks</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/HTTP/Headers/Strict-Transport-Security">HTTP Strict Transport Security</a> (HSTS)</td>
   <td>HSTS is used by servers to let them protect themselves from protocol downgrade and cookie hijack attacks by letting sites tell clients that they can only use HTTPS to communicate with the server</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Glossary/HTTP_2">HTTP/2</a></td>
   <td>While HTTP/2 technically does not <em>have</em> to use encryption, most browser developers are only supporting it when used with HTTPS, so it can be thought of in that regard as being security-related</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a></td>
   <td>Provides a way to determine the status of permissions for the current browser context</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/Security/Transport_Layer_Security">Transport Layer Security</a> (TLS); formerly known as Secure Sockets Layer (SSL)</td>
   <td>TLS provides security and privacy by encrypting data during transport over the network. This is the technology behind the <a href="/en-US/docs/Glossary/https">HTTPS</a> (HyperText Transport Protocol Secured) protocol</td>
  </tr>
 </tbody>
</table>

<p>Not all of these are generally directly used within code; notably, the <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a>, <a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a>, and the <code>allow</code> attribute on <code>&lt;iframe&gt;</code> elements are primary tools directly used by code to help secure a site and its content.</p>

<h2 id="Keeping_personal_data_safe">Keeping personal data safe</h2>

<h2 id="Managing_site_permissions">Managing site permissions</h2>

<h2 id="Bringing_it_all_together">Bringing it all together</h2>

<p>&lt;using Feature Policy with permissions and so forth; how to use them together, how they interact, etc&gt;</p>

<h3 id="Permission_requests_in_&lt;iframe&gt;_elements">Permission requests in &lt;iframe&gt; elements</h3>

<p>Things can get tricky when your web app uses the {{HTMLElement("iframe")}} element to embed content from another site inside your own, especially if the document you load into the frame has its own permission needs to consider.</p>

<p>While specifications for these technologies either state or recommend tactics for handling situations like this, browsers may offer different solutions to improve security even further or to try new features, or try to reduce complexity for users, among other possible reasons.</p>

<p>&lt;--- allow attribute, feature policy, and permissions api stuff ---&gt;</p>

<p>A specific user experience issue that often arises is a document that's loaded with permission to access a resource and the document contains an {{HTMLElement("iframe")}} with the {{htmlattrxref("allow", "iframe")}} attribute to delegate that permission to the contents of the frame. In this case, it's possible for the user to wind up being prompted repeatedly for that same resource, first by the main page, then by the document in the frame.</p>

<p>Browsers may choose to provide ways around this. For example, in Firefox 73, the user permission requests were revised so that when an <code>&lt;iframe&gt;</code> uses the <code>allow</code> keyword to delegate permission to the embeded document, the browser asks the user to grant the parent document permission to use the resource, and that permission is then shared with the embedded content that requested the resource to begin with.</p>

<p>&lt;-- diagram and/or code snippet to clarify things--&gt;</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Security">Web security</a></li>
 <li><a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Feature_Policy/Using_Feature_Policy">Using Feature Policy</a> and the HTTP {{HTTPHeader("feature-policy")}} header</li>
</ul>
